Skip to main content

Device Attributes Actions

https://api.app.wnology.io/applications/APPLICATION_ID/devices/DEVICE_ID/attributes

Below are the various requests that can be performed against the Device Attributes resource, as well as the expected parameters and the potential responses.

Get​

Returns the attributes for a device

Method And Url​

GET https://api.app.wnology.io/applications/APPLICATION_ID/devices/DEVICE_ID/attributes

Authentication​

A valid API access token is required to access this endpoint. The token must include at least one of the following scopes: all.Application, all.Application.read, all.Device, all.Device.read, all.Organization, all.Organization.read, all.User, all.User.read, deviceAttributes.*, or deviceAttributes.get.

Request Path Components​

Path ComponentDescriptionExample
APPLICATION_IDID associated with the application575ec8687ae143cd83dc4a97
DEVICE_IDID associated with the device575ecf887ae143cd83dc4aa2

Request Query Parameters​

NameRequiredDescriptionDefaultExample
sortFieldNField to sort the results by. Accepted values are: name, dataTypenamesortField=status
sortDirectionNDirection to sort the results by. Accepted values are: asc, descascsortDirection=asc
filterFieldNField to filter the results by. Blank or not provided means no filtering. Accepted values are: name, dataTypefilterField=status
filterNFilter to apply against the filtered field. Supports globbing. Blank or not provided means no filtering.filter=number

Request Headers​

NameRequiredDescriptionDefault
AuthorizationYThe token for authenticating the request, prepended with Bearer

Curl Example​

curl -H 'Content-Type: application/json' \
-H 'Accept: application/json' \
-H 'Authorization: Bearer YOUR_API_ACCESS_TOKEN' \
-X GET \
https://api.app.wnology.io/applications/APPLICATION_ID/devices/DEVICE_ID/attributes

Successful Responses​

CodeTypeDescription
200Device AttributesCollection of device attributes

Error Responses​

CodeTypeDescription
400ErrorError if malformed request
404ErrorError if device was not found

Post​

Adds a new attribute to a device

Method And Url​

POST https://api.app.wnology.io/applications/APPLICATION_ID/devices/DEVICE_ID/attributes

Authentication​

A valid API access token is required to access this endpoint. The token must include at least one of the following scopes: all.Application, all.Organization, all.User, deviceAttributes.*, or deviceAttributes.post.

Request Path Components​

Path ComponentDescriptionExample
APPLICATION_IDID associated with the application575ec8687ae143cd83dc4a97
DEVICE_IDID associated with the device575ecf887ae143cd83dc4aa2

Request Headers​

NameRequiredDescriptionDefault
AuthorizationYThe token for authenticating the request, prepended with Bearer

Request Body​

The body of the request should be serialized JSON that validates against the Device Attribute Post schema. For example, the following would be a valid body for this request:

{
"name": "voltage",
"dataType": "number"
}

Curl Example​

curl -H 'Content-Type: application/json' \
-H 'Accept: application/json' \
-H 'Authorization: Bearer YOUR_API_ACCESS_TOKEN' \
-X POST \
-d '{"name":"voltage","dataType":"number"}' \
https://api.app.wnology.io/applications/APPLICATION_ID/devices/DEVICE_ID/attributes

Successful Responses​

CodeTypeDescription
201Device AttributeSuccessfully created device attribute

Error Responses​

CodeTypeDescription
400ErrorError if malformed request
404ErrorError if device was not found

Schemas​

Device Attribute​

Schema for a single Device Attribute

Device Attribute Schema​

  • ▶
    {} 3 keys
    • "http://json-schema.org/draft-07/schema#"
    • "object"
    • ▶
      {} 8 keys
      • ▶
        {} 2 keys
        • ▶
          {} 2 keys
          • ▶
            {} 2 keys
            • ▶
              {} 2 keys
              • ▶
                {} 3 keys
                • ▶
                  {} 3 keys
                  • ▶
                    {} 2 keys
                    • ▶
                      {} 2 keys

                  Device Attribute Example​

                  • ▶
                    {} 4 keys
                    • "575ecf887ae143cd83dc4aa2"
                    • "575ec8687ae143cd83dc4a97"
                    • "voltage"
                    • "number"

                  Device Attribute Post​

                  Schema for the body of a Device Attribute creation request

                  Device Attribute Post Schema​

                  • ▶
                    {} 5 keys
                    • "http://json-schema.org/draft-07/schema#"
                    • "object"
                    • ▶
                      {} 6 keys
                      • ▶
                        {} 2 keys
                        • ▶
                          {} 2 keys
                          • ▶
                            {} 2 keys
                            • ▶
                              {} 2 keys
                              • ▶
                                {} 3 keys
                                • ▶
                                  {} 3 keys
                                • ▶
                                  [] 2 items
                                  • false

                                Device Attribute Post Example​

                                • ▶
                                  {} 2 keys
                                  • "voltage"
                                  • "number"

                                Device Attributes​

                                Schema for a collection of Device Attributes

                                Device Attributes Schema​

                                • ▶
                                  {} 3 keys
                                  • "http://json-schema.org/draft-07/schema#"
                                  • "object"
                                  • ▶
                                    {} 9 keys
                                    • ▶
                                      {} 2 keys
                                      • ▶
                                        {} 1 key
                                        • ▶
                                          {} 1 key
                                          • ▶
                                            {} 1 key
                                            • ▶
                                              {} 1 key
                                              • ▶
                                                {} 1 key
                                                • ▶
                                                  {} 2 keys
                                                  • ▶
                                                    {} 2 keys
                                                    • ▶
                                                      {} 2 keys

                                                  Device Attributes Example​

                                                  • ▶
                                                    {} 7 keys
                                                    • ▶
                                                      [] 1 item
                                                      • 1
                                                      • 1
                                                      • "name"
                                                      • "asc"
                                                      • "575ec8687ae143cd83dc4a97"
                                                      • "575ecf887ae143cd83dc4aa2"

                                                    Error​

                                                    Schema for errors returned by the API

                                                    Error Schema​

                                                    • ▶
                                                      {} 3 keys
                                                      • "http://json-schema.org/draft-07/schema#"
                                                      • "object"
                                                      • ▶
                                                        {} 2 keys
                                                        • ▶
                                                          {} 1 key
                                                          • ▶
                                                            {} 1 key

                                                        Error Example​

                                                        • ▶
                                                          {} 2 keys
                                                          • "NotFound"
                                                          • "Application was not found"

                                                        Was this page helpful?


                                                        Still looking for help? You can also search the WEGnology Forums or submit your question there.